#include "vtkPolyDataMapper.h"
#include "vtkPolyDataReader.h"
#include "vtkActor.h"
#include "vtkCamera.h"
// FLTK (needed for the call to Fl::run())
#include <FL/Fl.H>
// vtkFLTK
#include "Viewer3D.h"
#include <FL/Fl_File_Chooser.H>

Viewer3D::Viewer3D(int x, int y, int w, int h, const char *l) 
:Fl_VTK_Window(x,  y, w, h, l) 
{

}

Viewer3D::~Viewer3D() {

}

void Viewer3D::Load() {
  std::cout << "Leyendo " << std::endl;
  m_filename = fl_file_chooser("Image VTK Filename ","*.{vtk}","");
  vtkActor*          Actor  = vtkActor::New();
  vtkPolyDataMapper* Mapper = vtkPolyDataMapper::New();
  vtkPolyDataReader* reader = vtkPolyDataReader::New();
  reader->SetFileName(m_filename);
  reader->Update();
  // Connect the Source to the Mapper and decrement its reference count.
  Mapper->SetInput(reader->GetOutput());
  
  // Connect the Mapper to the Actor and decrement its reference count.
  Actor->SetMapper(Mapper);
  Mapper->Delete();
  // Add Actor to default renderer and decrement its reference count.
  this->AddProp(Actor);
  Actor->Delete();
}


